require( 'deepcompare' )

module( ..., package.seeall )

local table = require( 'table' )
local os = require( 'os' )

local geometry = require( 'saotrace.geometry' )

local srcdir = os.getenv('srcdir') or '.'

local db = table.concat( { srcdir, 'data', 'geometry.rdb'}, '/' )

function test_function ()

   local entries, vars = geometry.read{ file = db }

   assert_true( deepcompare( vars, { node = '24.9555' } ), 'header vars' )

   assert_equal( 8, #entries )

   assert_equal( 0, entries[1].rthick, "default thickness" )

   assert_equal( 1, entries[1].shell, "shell" )

   assert_equal( 'h', entries[1].optic, "optic" )

   assert_equal( "h1", entries[1].mirror  )

end

function test_iterator ()

   local entries = geometry.read{ file = db }

   local iter, vars = geometry.read{ file = db, mode = 'iterator' }

   assert_true( deepcompare( vars, { node = '24.9555' } ), 'header vars' )

   local i = 0
   for entry in iter do

      i = i + 1

      assert_true( deepcompare( entry, entries[i] ), i )

   end

   assert_equal( #entries, i )

end
